whoa = {}
cfg = {}

-- -- whoa default settings.
local function loadDefaults()
	if cfg.cfg == nil then cfg.cfg = true; end
	if cfg.smallAuraSize == nil then cfg.smallAuraSize = 20; end
	if cfg.largeAuraSize == nil then cfg.largeAuraSize = 27; end
	if cfg.classColor == nil then cfg.classColor = true; end
	if cfg.reactColor == nil then cfg.reactColor = true; end
	if cfg.blizzColors == nil then cfg.blizzColors = false; end
	if cfg.usePartyFrames == nil then cfg.usePartyFrames = true; end
	if cfg.showPartyPets == nil then cfg.showPartyPets = false; end
	if cfg.bigAuras == nil then cfg.bigAuras = true; end
	if cfg.useBossFrames == nil then cfg.useBossFrames = true; end
	if cfg.whoaTexture == nil then cfg.whoaTexture = true; end
	if cfg.whoaTextureIndex == nil then cfg.whoaTextureIndex = 1; end
	if cfg.noClickFrame == nil then cfg.noClickFrame = false;	end
	if cfg.SBTextureName == nil then cfg.SBTextureName = "whoa";	end
	if cfg.selectedTexture == nil then cfg.selectedTexture = 5;	end
	if cfg.frameMode == nil then cfg.frameMode = "light";	end
	if cfg.darkFrames == nil then cfg.darkFrames = false;	end
	if cfg.minimapZoom == nil then cfg.minimapZoom = true;	end
end

local function loadSettings()
	if cfg.classColor==true then whoaCheckButton2:SetChecked(true) end
	if cfg.reactColor == true then whoaCheckButton3:SetChecked(true) end
	if cfg.blizzColors == true then whoaCheckButton4:SetChecked(true) end
	if cfg.bigAuras == true then whoaCheckButton5:SetChecked(true) end
	if cfg.styleFont == true then whoaCheckButton6:SetChecked(true) end
	-- if cfg.usePartyFrames == true then whoaCheckButton7:SetChecked(true) end
	if cfg.darkFrames == true then whoaCheckButton7:SetChecked(true) end
	if cfg.usePartyFrames == true then whoaCheckButton8:SetChecked(true) end
		-- if cfg.comboPointFrame == true then whoaCheckButton9:SetChecked(true) end
	-- if cfg.threatShowNumeric == true then whoaCheckButton10:SetChecked(true) end
	if cfg.showPartyPets == true then whoaCheckButton9:SetChecked(true) end
	if cfg.minimapZoom == true then whoaCheckButton10:SetChecked(true) end
	if cfg.noClickFrame == true then whoaCheckButton11:SetChecked(true) end
end
-- loadSettings()
function SBTexturesDo()
	for i, v in pairs ({ PlayerFrameHealthBar, PlayerFrameManaBar, PlayerFrameHealthBar.AnimatedLossBar, PlayerFrameAlternateManaBar,
		PetFrameHealthBar, PetFrameManaBar, TargetFrameHealthBar, TargetFrameManaBar, FocusFrameHealthBar,
		FocusFrameManaBar, TargetFrameToTHealthBar, FocusFrameToTHealthBar }) do
		v:SetStatusBarTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\statusbar\\"..cfg.SBTextureName); end
	for i, v in pairs ({ PlayerFrameMyHealPredictionBar, }) do
		v:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\statusbar\\"..cfg.SBTextureName); end
	for i = 1, 4 do
		if _G["PartyMemberFrame"..i] then
			_G["PartyMemberFrame"..i.."HealthBar"]:SetStatusBarTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\statusbar\\"..cfg.SBTextureName);
			_G["PartyMemberFrame"..i.."ManaBar"]:SetStatusBarTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\statusbar\\"..cfg.SBTextureName)
		end
	end
end

function dynamicFramesDo(self, unit)
	local path = cfg.frameMode;
	
	if self then
		local classification = UnitClassification(self.unit);
		if ( classification == "worldboss" or classification == "elite" ) then
			self.borderTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-TargetingFrame-Elite");
		elseif ( classification == "rareelite" ) then
			self.borderTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-TargetingFrame-Rare-Elite");
		elseif ( classification == "rare" ) then
			self.borderTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-TargetingFrame-Rare");
		else
			self.borderTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-TargetingFrame");
		end
		if ( self.showPVP ) then
			local factionGroup = UnitFactionGroup(self.unit);
			if ( UnitIsPVPFreeForAll(self.unit) ) then
					self.pvpIcon:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-PVP-FFA");
			elseif ( factionGroup and factionGroup ~= "Neutral" and UnitIsPVP(self.unit) ) then
					self.pvpIcon:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-PVP-"..factionGroup);
			end
		end
	end
end

function darkFramesDo(self)
	local path = cfg.frameMode;
	
	PlayerFrameTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-TargetingFrame");
	PetFrameTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-SmallTargetingFrame");
	TargetFrameToTTextureFrameTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-TargetofTargetFrame");
	FocusFrameToTTextureFrameTexture:SetTexture("Interface\\Addons\\whoaThickFrames_BCC\\media\\"..path.."\\UI-TargetofTargetFrame");
end

local function fontStyleDo()
	local fontFamily;
	if (cfg.styleFont) then
		fontFamily = "SystemFont_Outline_Small";
	elseif not (cfg.styleFont) then
		fontFamily = "NumberFontNormal";
	end
	
	for i, v in pairs({	PlayerFrameHealthBarText, PlayerFrameHealthBarTextLeft,	PlayerFrameHealthBarTextRight,
		PlayerFrameManaBarTextLeft,	PlayerFrameManaBarTextRight, PlayerFrameTextureFrameManaBarText,
		TargetFrameTextureFrame.HealthBarText, TargetFrameTextureFrame.HealthBarTextLeft, TargetFrameTextureFrame.HealthBarTextRight,
		TargetFrameTextureFrame.ManaBarText, TargetFrameTextureFrame.ManaBarTextLeft, TargetFrameTextureFrame.ManaBarTextRight,
		FocusFrameTextureFrame.HealthBarText, FocusFrameTextureFrame.HealthBarTextLeft,	FocusFrameTextureFrame.HealthBarTextRight,
		FocusFrameTextureFrame.ManaBarText,	FocusFrameTextureFrame.ManaBarTextLeft,	FocusFrameTextureFrame.ManaBarTextRight, }) do 
		if v then v:SetFontObject(fontFamily); end
	end
end
-- fontStyleDo("TargetFrame")

-- Font strings factory
function whoa:CreateFont(frame, name, text, x, y, font, size )
	if size == nil then size = 15 end
	if font == nil then font = STANDARD_TEXT_FONT end
local fontString = frame:CreateFontString(name) fontString:SetPoint("TOPLEFT", x, y) fontString:SetFont(font, size, "") fontString:SetText(text)
return (fontString)
end

-- Checkbuttons factory.
local uniquealyzer = 1;
local function createCheckbutton(parent, x_loc, y_loc, displayname)
	uniquealyzer = uniquealyzer + 1;
	local checkbutton = CreateFrame("CheckButton", "whoaCheckButton" .. uniquealyzer, parent, "ChatConfigCheckButtonTemplate");
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
	return checkbutton;
end

-- Buttons factory.
function whoa:CreateButton(frame, name, text, width, height, x, y, template)
if (template == nil) then template = "OptionsButtonTemplate"
end
local button = CreateFrame("Button", name, frame, template) button:SetPoint("TOPLEFT", x, y) button:SetWidth(width)
button:SetHeight(height) button:SetText(text)
return (button)
end

-- Disable/enable unit frames click interaction.
function disableFramesClick()
	if (cfg.noClickFrame == true) then
		for i, v in pairs({	PlayerFrame, PetFrame, TargetFrame, FocusFrame }) do v:SetMouseClickEnabled(false); end
	elseif (cfg.noClickFrame == false) then
		for i, v in pairs({	PlayerFrame, PetFrame, TargetFrame, FocusFrame }) do v:SetMouseClickEnabled(true); end
	end
end

-- Mouse wheel minimap zoom.
function minimapZoomHack()
	if (cfg.minimapZoom == true) then
		Minimap:EnableMouseWheel(true)
		Minimap:SetScript("OnMouseWheel", function(mp, input)
		local zoom = Minimap:GetZoom()
			if input > 0 and zoom < 5 then
				mp:SetZoom(zoom +1)
			elseif input < 0 and zoom > 0 then
				mp:SetZoom(zoom -1)
			end
			C_Timer.After(10, function()
				mp:SetZoom(0)
			end)
		end)
	elseif (cfg.minimapZoom == false) then
		Minimap:SetScript("OnMouseWheel", nil)
		Minimap:SetZoom(0)
	end
end

optionUI = {}
optionUI.panel = CreateFrame( "Frame", "optionUI", UIParent );
optionUI.panel.name = "whoa UnitFrames";
InterfaceOptions_AddCategory(optionUI.panel);
local addonName = GetAddOnMetadata("whoathickframes_bcc", "title")
local addonVer = GetAddOnMetadata("whoathickframes_bcc", "version")

--	Option panel frame.
local whoaMenu = CreateFrame("Frame", "myframe", UIParent);
whoaMenu:RegisterEvent("PLAYER_LOGIN")
whoaMenu:SetScript("OnEvent", function(self)

	local title = whoa:CreateFont(optionUI.panel, "title", ""..addonName..addonVer.."", 15, -18, font, 15)
	title:SetFontObject(GameFontNormal)
	title:SetPoint("LEFT",optionUI.panel,"TOPLEFT",0,0)
	-- local disclaimer = whoa:CreateFont(optionUI.panel, "disclaimer", "Most options require a reload (/rl) for correct aplication of changes.", 15, -40, font, 12)
	-- disclaimer:SetPoint("LEFT",optionUI.panel,"TOPLEFT",0,0)

	local xOffset = -80;
	--	Class colors.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset, " Players class colores.");
	myCheckButton.tooltip = " Non players health bars colored by class.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton2:GetChecked() then
			cfg.classColor = true;
		else
			cfg.classColor = false;
		end
	end );
	--	Reaction colors
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-30, " Unit reaction colors");
	myCheckButton.tooltip = "Non players health bars colored by reaction or RPG.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton3:GetChecked() then
			cfg.reactColor = true;
		else
			cfg.reactColor = false;
			cfg.blizzColors = false;
			whoaCheckButton4:SetChecked(false);
		end
	end );
	--	Bright reaction colors.
	myCheckButton = createCheckbutton(optionUI.panel, 300, xOffset-30, " Use Blizzards reaction colors.");
	myCheckButton.tooltip = "Set reaction colot palette WoW default making it brighter.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton4:GetChecked() then
			cfg.reactColor = true;
			cfg.blizzColors = true;
			whoaCheckButton3:SetChecked(true);
		else
			cfg.blizzColors = false;
			whoaCheckButton4:SetChecked(false);
		end
	end );
	--	Aura size.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-60, " Enlarge buff and debuff icons.");
	myCheckButton.tooltip = "Enlarges buff and debuff icons on target and focus frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton5:GetChecked() then
			cfg.largeAuraSize = 28			--	max row width is 122. This is 4 buffs in a row.
			cfg.smallAuraSize = 24
			cfg.bigAuras = true;
		else
			cfg.largeAuraSize = 21			--	default size. This is 5 in a row.
			cfg.smallAuraSize = 17
			cfg.bigAuras = false;
		end
	end );
	
	--	Blizzard status text.
	myCheckButton = createCheckbutton(optionUI.panel, 300, xOffset-60, "Use retail font style.");
	-- myCheckButton:SetEnabled(false);
	myCheckButton.tooltip = "Displays Blizzard´s default font style for player and target frames status text.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton6:GetChecked() then
			cfg.styleFont = true;
			-- fontStyleDo("TargetFrame")
			fontStyleDo(TargetFrame)
		else
			cfg.styleFont = false;
			-- fontStyleDo("TargetFrame")
			fontStyleDo(TargetFrame)
		end
	end );
		
	--	Statusbar textures.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-90, " Dark unit frames.");
	myCheckButton.tooltip = "Enables dark texture frames for dark themed Ui.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton7:GetChecked() then
			cfg.frameMode = "dark";
			cfg.darkFrames = true;
			darkFramesDo()
			dynamicFramesDo(TargetFrame)
			dynamicFramesDo(FocusFrame)
		else
			cfg.frameMode = "light";
			cfg.darkFrames = false;
			darkFramesDo()
			dynamicFramesDo(TargetFrame)
			dynamicFramesDo(FocusFrame)
		end
	end );
	
	--	Party frames.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-220, " Party frames.");
	myCheckButton.tooltip = "Applies whoa themed party frames when not using raid frames";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton8:GetChecked() then
			cfg.usePartyFrames = true;
		else
			cfg.usePartyFrames = false;
		end
	end );
	
	--	Pets on party frames.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-250, " Show pets in patry.");
	myCheckButton.tooltip = "Displays pet frames on party frames when non in raid mode.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton9:GetChecked() then
			SetCVar("showPartyPets",1)
			cfg.showPartyPets = true;
		else
			SetCVar("showPartyPets",0)
			cfg.showPartyPets = false;
		end
	end );
	
	-- -- combo points
	-- myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-190, " Combo points location.");
	-- myCheckButton.tooltip = "Set legacy combo points on target frame.";
	-- -- myCheckButton:SetEnabled(false);
	-- myCheckButton:SetScript("OnClick",
	-- function(self)
		-- if whoaCheckButton10:GetChecked() then
			-- SetCVar("comboPointLocation",1)
			-- cfg.comboPointFrame = true;
		-- else
			-- SetCVar("comboPointLocation",2)
			-- cfg.comboPointFrame = false;
		-- end
	-- end );
	-- --	Old threat numeric indicator.
	-- myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-220, "Threat numeric indicator.");
	-- myCheckButton.tooltip = "Enables threat numeric indicator over player frame.";
	-- myCheckButton:SetScript("OnClick",
	-- function(self)
		-- if whoaCheckButton10:GetChecked() then
			-- SetCVar("threatShowNumeric",1)
			-- cfg.threatShowNumeric = true;
		-- else
			-- SetCVar("threatShowNumeric",0)
			-- cfg.threatShowNumeric = false;
		-- end
	-- end );
		
	--	minimap mouswheel zoom.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-280, " Minimap mousewheel zoom.");
	myCheckButton.tooltip = "Use whoa´s legacy texture on status bars.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton10:GetChecked() then
			cfg.minimapZoom = true;
			minimapZoomHack()
		else
			cfg.minimapZoom = false;
			minimapZoomHack()
		end
	end );
	
	--	Click interaction switch.
	myCheckButton = createCheckbutton(optionUI.panel, 40, xOffset-370, "Click through frames.");
	myCheckButton.tooltip = "Disable click interaction for player/target/focus frames.";
	-- myCheckButton:SetEnabled(false);
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton11:GetChecked() then
			cfg.noClickFrame = true;
			disableFramesClick()
		else
			cfg.noClickFrame = false;
			disableFramesClick()
		end
	end );
	
	-- Frames centering / restore.
	local positionOptions = whoa:CreateFont(optionUI.panel, "mainOptions", "Positioning options.", 25, xOffset-350, font, 13)
	mainOptions:SetPoint("LEFT",optionUI.panel,"TOPLEFT",0,0)
	local centerBttnInfo = whoa:CreateFont(optionUI.panel, "centerBttnInfo", "Center player and target frames middle screen.", 50, -500, font, 12)
	mainOptions:SetPoint("LEFT",optionUI.panel,"TOPLEFT",0,0)
	local centerBttn = CreateFrame("Button", "centerButton", optionUI.panel, "UIPanelButtonTemplate")
	centerBttn:SetSize(110 ,25)
	centerBttn:SetText("Center frames")
	centerBttn:SetPoint("BOTTOMLEFT",70,20)
	centerBttn:SetScript("OnClick", function()
		local x,y = -20,-150 for i,f in pairs({PlayerFrame,TargetFrame}) do f:ClearAllPoints() f:SetPoint(i==1 and "RIGHT" or "LEFT",UIParent,"CENTER",i==1 and x or -x,y) f:SetUserPlaced(true) end
	end)
	-- Reset.
	local resetBttn = CreateFrame("Button", "resetButton", optionUI.panel, "UIPanelButtonTemplate")
	resetBttn:SetSize(100 ,25)
	resetBttn:SetText("Reset frames")
	resetBttn:SetPoint("BOTTOMLEFT",210,20)
	resetBttn:SetScript("OnClick", function()
		PlayerFrame_ResetUserPlacedPosition()
		TargetFrame_ResetUserPlacedPosition()
	end)
	-- -- Reload
	-- local reloadBttn = CreateFrame("Button", "reloadButton", optionUI.panel, "UIPanelButtonTemplate")
		-- reloadBttn:SetSize(80 ,22)
		-- reloadBttn:SetText("Reload UI")
		-- reloadBttn:SetPoint("BOTTOMRIGHT",-20,20)
		-- reloadBttn:SetScript("OnClick", function()
		-- ReloadUI()
	-- end)

	-- texture selector.
	local fancyOptions = whoa:CreateFont(optionUI.panel, "textureSelector", "Statusbar texture selector:", 60, xOffset-155, font, 12)
	-- fancyOptions:SetPoint("LEFT",optionUI.panel,"TOPLEFT",0,0)

	CreateFrame("Button", "dropSelector", optionUI.panel, "UIDropDownMenuTemplate")
	dropSelector:ClearAllPoints()
	dropSelector:SetPoint("CENTER", 50, 40)
	dropSelector:Show()

	local items = {
		"Whoa",
		"Blizzard",
		"65 %",
		"Neon"
	}

	local function OnClick(self)
		UIDropDownMenu_SetSelectedID(dropSelector, self:GetID())
		if (UIDropDownMenu_GetSelectedID(dropSelector)==1) then
			cfg.SBTextureName = "whoa";
			cfg.whoaTextureIndex = 1;
		elseif (UIDropDownMenu_GetSelectedID(dropSelector)==2) then
			cfg.SBTextureName = "blizzard";
			cfg.whoaTextureIndex = 2;
		elseif (UIDropDownMenu_GetSelectedID(dropSelector)==3) then
			cfg.SBTextureName = "65";
			cfg.whoaTextureIndex = 3;
		elseif (UIDropDownMenu_GetSelectedID(dropSelector)==4) then
			cfg.SBTextureName = "neon";
			cfg.whoaTextureIndex = 4;
		end
		SBTexturesDo()
	end
	local function initialize(self, level)
	local info = UIDropDownMenu_CreateInfo()
	for k,v in pairs(items) do
		info = UIDropDownMenu_CreateInfo()
		info.text = v
		info.value = k
		info.func = OnClick
		UIDropDownMenu_AddButton(info, level)
	end
end

	UIDropDownMenu_Initialize(dropSelector, initialize)
	UIDropDownMenu_SetWidth(dropSelector, 100);
	UIDropDownMenu_SetButtonWidth(dropSelector, 124)
	UIDropDownMenu_SetSelectedID(dropSelector, cfg.whoaTextureIndex)
	UIDropDownMenu_JustifyText(dropSelector, "LEFT")
end)

-- slash commands.
SlashCmdList.optionUI = function()
	InterfaceOptionsFrame_OpenToCategory(optionUI.panel)
	InterfaceOptionsFrame_OpenToCategory(optionUI.panel)
end

SLASH_optionUI1 = "/optionUI"
SLASH_optionUI1 = "/wut"
SLASH_optionUI1 = "/whoaf"

SlashCmdList['RELOAD'] = function() ReloadUI() end
SLASH_RELOAD1 = '/rl'

local whoaInit = CreateFrame("Frame")
whoaInit:RegisterEvent("PLAYER_ENTERING_WORLD");
whoaInit:RegisterEvent("ADDON_LOADED");
whoaInit:RegisterEvent("PLAYER_LOGIN");
whoaInit:SetScript('OnEvent', function(self, event, ...)
	if (event == "PLAYER_LOGIN") then
		if IsAddOnLoaded("whoaThickFrames") then
			print("|cff00ccff ["..addonName..addonVer.."] |cff888888is now loaded. Use |cffffff00'/whoaf' |cff888888to view options.");
		end
	elseif (event == "PLAYER_ENTERING_WORLD") then
		loadDefaults()
		loadSettings()
		SBTexturesDo()
		minimapZoomHack()
		disableFramesClick()
	end
end)

